import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;


public class Debugger implements Runnable {
    Manager M;
    boolean HALT;


    public Debugger() {
	HALT=true;
    }

    public Debugger(Manager MM) {
	this.M=MM;
	HALT=true;
    }


    public void run() {
	int mode=0;
	int choice=0;
	try{choice=M.DB.DEBUG.mode;}
	catch(Exception e) {}

	if(choice==0) {
	    System.out.println("arithmetic tests");
            DebugArithmetic.test0();
	    DebugArithmetic.test1();
	    DebugArithmetic.test2();
	    DebugArithmetic.test3();
	    DebugArithmetic.test4();
	}
	if(choice==1) {
	    System.out.println("data checks");
            DebugData.test0();
            DebugData.test1();
            DebugData.test2();
            DebugData.test3();
	}
	if(choice==2) {
	    System.out.println("composition checks");
	    DebugComposition.test0();
            DebugComposition.test1();
	    DebugComposition.test2();
	    DebugComposition.test3();
	    DebugComposition.test4();
	}

	if(choice==3) test3();
	if(choice==4) test4();
	if(choice==5) test5();
	if(choice==6) test6();
	if(choice==7) test7();
    }



    /**checks that our positivity routine works.*/

    public void test3() {
	System.out.println("QI and QI2 positivity");
	HALT=false;
	int count=0;
	while(HALT==false) {
	   ++count;
	   QI A=randomUnitQI01();
	   int test=A.sign();
	   double a=A.toDouble();
	   boolean bad=false;
	   if((test==-1)&&(a>=0)) bad=true;
	   if((test==+1)&&(a<=0)) bad=true;
           QI2 A2=randomQI2();
           int test2=A2.sign();
	   double a2=A2.toDouble();
           if((test2==-1)&&(a2>=0)) bad=true;
	   if((test2==+1)&&(a2<=0)) bad=true;
           if(bad==true) {
	       System.out.println("undetected positive");
	       A2.print();
	       HALT=true;
	   }
	   if(count%1000==0) System.out.println(count);
	}

    }



    /**This gives a feel for the kind of polynomials we use in the
       confiner and excluder tests.*/

    public void test4() {

	 QI2RationalMap X=DataMap.map(1,4);
	 QI2[] A=DataPartitionManager.point(23);
	 QI2[] B=DataPartitionManager.point(24);
	 QI2[] C=DataPartitionManager.point(33);

	 QI2[] P=DataPartitionManager.point(15);
	 QI2[] Q=DataPartitionManager.point(10);

	 QI2Polygon T=new QI2Polygon(A,B,C);

	 QI2RationalFunction F=X.confineRational(P,Q);
	 QI2Polynomial R=F.P;
	 R=R.moveTriangle(T);
	 R=R.squareTriangleTransform();

	  System.out.println("exact polynomial");
	  R.print();	
          System.out.println("");
	  System.out.println("numerical polynomial");
	  R.printN();
    }



    /**print out numerical values of points*/

  public void test5() {
	for(int i=1;i<113;++i) {
	    QI2[] X=DataPartitionManager.point(i);
	    double[] x={X[0].toDouble(),X[1].toDouble()};
               System.out.print("public static double[] point"+i);
               System.out.print("() {double[] x={");
	       System.out.println(x[0]+","+x[1]+"};return(x);}");
	}
  }



    /**computes information about the differential*/


    public void test6() {
	HALT=false; 
	long count=0;
	int k=SelectPartition.TILE;
	double max1=0;
	double max2=0;
	double max3=0;
	double mindet=1000;
	double maxdet=-1000;
	double[][] minA={{1000,1000},{1000,1000}};
	double[][] maxA={{-1000,-1000},{-1000,-1000}};
	double[] minB={1000,1000};
	double[] maxB={-1000,-1000};
	double[] minC={1000,1000};
	double[] maxC={-1000,-1000};
        PolyVector P=M.P.DOMAIN.toDouble();

	M.P.POINTCOUNT=0;
        while(HALT==false) {
	  ++count; 
	  int[] A=M.C.MC.getMap();
	  double[] X=PolyVector.random(P); 

	  double[][] m=DebugDifferential.diffMap(A,X,.0001); 
	  double det=m[0][0]*m[1][1]-m[0][1]*m[1][0];
	  if(mindet>det) mindet=det;
	  if(maxdet<det) maxdet=det;
	  if(det<0) {
	      M.P.POINT[M.P.POINTCOUNT]=new Complex(X[0],X[1]);
	      ++M.P.POINTCOUNT;
	  }


	  QI2RationalMap F=DataMap.map(A);
	  QI2RationalFunction DDF=QI2Differential.detD(F);
	  double det2=DDF.evaluate(X[0],X[1]);




	  double norm1=0;
	  norm1=norm1+m[0][0]*m[0][0]+m[0][1]*m[0][1];
	  double norm2=0;
	  norm2=norm2+m[1][0]*m[1][0]+m[1][1]*m[1][1];

	  if(max1<norm1) max1=norm1;
	  if(max2<norm2) {
                 max2=norm2;
		 M.P.SOURCE=new Complex(X[0],X[1]);
	  }
	  max3=Math.sqrt(max1+max2);



	  double[] v1=new double[2];
	  double[] v2=new double[2];
	  /**apply m to the vector (2,1)*/
	  v1[0]=2*m[0][0]+m[0][1];
	  v1[1]=2*m[1][0]+m[1][1];
	  /**apply m to the vector (2,1)*/
	  v2[0]=2*m[0][0]-m[0][1];
	  v2[1]=2*m[1][0]-m[1][1];


	  for(int i=0;i<2;++i) {
	      for(int j=0;j<2;++j) {
		  if(minA[i][j]>m[i][j]) minA[i][j]=m[i][j];
		  if(maxA[i][j]<m[i][j]) maxA[i][j]=m[i][j];
		  if(minB[j]>v1[j]) minB[j]=v1[j];
		  if(maxB[j]<v1[j]) maxB[j]=v1[j];
		  if(minC[j]>v2[j]) minC[j]=v2[j];
		  if(maxC[j]<v2[j]) maxC[j]=v2[j];
	      }
	  }




            if(count%10==0) {
		System.out.println("-----piece "+k+" ----------");  
		System.out.println("max m00^2+m01^2 "+max1);
		System.out.println("max m10^2+m11^2 "+max2);
		System.out.println("max norm "+max3);
        	System.out.println("min det "+mindet);
        	System.out.println("max det "+maxdet);
	    }
	}
    }

    public void test7() {
	System.out.println("recognizing point on picture canvas");
	System.out.println("takes a while for a big search...");
	double x=M.P.SOURCE.x;
	double y=M.P.SOURCE.y;
	System.out.println("the point:  "+x+" "+y);
	System.out.println("first, the error of approx is printed:");
	QI2 qx=QI2.recognize(x);
	QI2 qy=QI2.recognize(y);
	System.out.println("the QI2 approximation");
	qx.print();
	System.out.println("");
	qy.print();
	System.out.println("");
	System.out.println("done");
    }


    /**prints an integer string*/

    public static void print(int[] t) {
	int n=t.length;
	for(int i=0;i<n;++i) System.out.print(t[i]+" ");
	System.out.println("");
    }



    /**produces a random QI cubic rational function*/

    public static QI2RationalFunction randomCubicRat() {
	QI2RationalFunction F=new QI2RationalFunction();
	F.P=randomCubic2();
	F.Q=randomCubic2();
	return(F);
    }

    /**produces a random QI2 cubic */

    public static QI2Polynomial randomCubic2() {
	QI2Polynomial P=new QI2Polynomial();
	for(int i=0;i<3;++i) {
	    for(int j=0;j<3;++j) {
		P.c[i][j]=randomQI2();
	    }
	}
	return(P);
    }

    /**produces a random QI 3x3 matrix with values <100*/

    public static long[][] randomMatrix3() {
	long[][] A=new long[3][3];
	for(int i=0;i<3;++i) {
	    for(int j=0;j<3;++j) {
		A[i][j]=random(20);
	    }
	}
	return(A);
    }

    /**produces a random QI2*/

    public static QI2 randomQI2() {
	QI2 q=new QI2(randomQI(),randomQI(),5+random(5));
	return(q);
    }

    /**produces a random QI in unit square*/
   public static QI[] randomUnitQI() {
       QI[] x={randomUnitQI01(),randomUnitQI01()};
       return(x);
   }


    /**produces a random QI in [0,1]*/
   public static QI randomUnitQI01() {
       QI q=new QI(random(1000000),random(1000000));
       long a=(long)(Math.floor(q.toDouble()));
       QI r=new QI(a,0);
       q.a=q.a.subtract(r.a);
       return(q);
   }

    /**produces a random QI*/

    public static QI randomQI() {
	QI q=new QI(random(20000),random(20000));
	return(q);
    }

    /**produces a random long*/

    public static long random(int LIM) {
	long a=(long)(Math.floor(LIM*Math.random())-LIM/2);
	return(a);
    }

    public static long verySmallRandom() {
	long a=(long)(Math.floor(6*Math.random()));
	return(a);
    }


    /**generates a random integer amongst 0,1,...,(k-1)*/

    public static int randomPos(int k) {
	double d=Math.random();
	return((int)(Math.floor(k*d)));
    }




}