import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;




public class DocumentInfoPanel {

    public DocumentInfoPanel() {}

    public static void explain(Manager M,String S) {
	try {
           M.D.setExplain(S);
           M.D.repaint();
	}
	catch(Exception e) {}
    }


    public static void algebraInfo(Manager M) {
        String S="info: algebra";

	S=S+"\n\nThis feature shows you formulas for elements of the heat semigroup in which the heat map appears with exponent 0 or 1.  For the purposes of giving rigorous proofs, we only care about these elements. In all cases, the rational maps are defined over the number ring Z[\u03D5].";

	S=S+"\n\nH is the heat map in flag coordinates.";

	S=S+"\n\n\u0393 is the Gauss group.  It is generated by the Gauss recurrence G and the reflection R.";

	S=S+"\n\nB is the coordinatewise Mobius map which normalizes so that the star-regular and regular pentagons correspond respectively to the origin and the point at infinity out the diagonal line.";

	S=S+"\n\nThe map selector selects the element M_abc=B R^a G^b H^c B_inverse.";

    }

    public static void auxiliaryDisplayInfo(Manager M) {
        String S="information panel";

	S=S+"\n\nThis panel lets you display some information about the system. You can see the geometrical construction of the projective heat map, and algebraic formulas for the maps, and a demonstration of the behavior of the Gauss map.";

	explain(M,S);
    }

    public static void heatInfo(Manager M) {
        String S="info: heat map construction";
	S=S+"\n\nIn the figure, the yellow pentagon is the initial pentagon.  The white pentagon is the image under the projective heat map.  The other lines are auxiliary to the construction.  The figure shows the construction for a regular pentagon.  The general case follows the same pattern, though the geometry could be much different if the initial pentagon is not convex.";

	S=S+"\n\nThe figure also shows the construction of the flag invariants for the pentagon. The formulas at the bottom left are meant to be the cross ratios of the corresponding points.  There are 5 cross ratios one can take in all, and we use two consecutive ones (in the sense shown) for the coordinates.  Were we to choose a different pair of consecutive ones, we would compose the heat map with an element of the Gauss group.";
	S=S+Documentation.gaussAction();
	explain(M,S);
    }


    public static void gaussInfo(Manager M) {
        String S="info: Gauss group action";

	S=S+"\n\nThis feature illustrates the result that the blue triangle really is a fundamental domain for the Gauss group. To understand the demo, click on the info buttons on the Gauss control panel going from top to bottom.  If you want to see how these pieces interact with the Julia set, you can change the colors on the display so that they are somewhat transparent.";

	S=S+Documentation.gaussAction();
	explain(M,S);
    }

    public static void gaussPiece1Info(Manager M) {
        String S=gaussPiece1();
	S=S+Documentation.gaussAction();
	explain(M,S);
    }

    public static void gaussPiece2Info(Manager M) {
        String S=gaussPiece2();
	S=S+Documentation.gaussAction();
	explain(M,S);
    }

    public static void gaussPiece3Info(Manager M) {
        String S=gaussPiece3();
	S=S+Documentation.gaussAction();
	explain(M,S);
    }

    public static void gaussPiece4Info(Manager M) {
        String S=gaussPiece4();
	S=S+Documentation.gaussAction();
	explain(M,S);
    }



    public static String gaussPiece1() {
        String S="gauss map argument A";

	S=S+"\n\nWe have partitioned the fundamental triangle \u03A9 into 3 pieces, which are initially red, blue, magenta.  Each of the first 3 buttons toggles the display of some images of these pieces according to the following scheme.";
	S=S+"\n\nred: the entire Gauss group.";
	S=S+"\n\nmagenta: the 6 elements (0,j,0) and (0,k,1) for k=0,1,2.";
	S=S+"\n\nblue: the two elements (0,0,0) and (1,0,0).";
	S=S+"\n\nThe union of all these images is a square, A.  This gives a visual display that every point in A is mapped into \u03A9 by an element of the Gauss group.";

	return(S);
    }

    public static String gaussPiece2() {
        String S="gauss map argument B";

	S=S+"\n\nThe orange rectangle B lies to the left of A.  Really, B is supposed to be an infinite half-strip, but we have truncated B at -200 for the sake of rendering.  The orange (smooth) triangle shows the image of B under the map (1,1,0).  This illustrates that every point in B is mapped into A by by an element of the Gauss group.  Hence, by Step A, every element of B is mapped to \u03A9 by  by an element of the Gauss group.";
	return(S);
    }


    public static String gaussPiece3() {
        String S="gauss map argument C";

	S=S+"\n\nThe purple half-strip C (truncated to a rectangle) contains all points to the left of A and below B. The map (4,1,0) carries C into B.  Hence, by step B, every element of C is mapped into \u03A9 by by an element of the Gauss group.";

	return(S);
    }


    public static String gaussPiece4() {
        String S="gauss map argument D";

    S=S+"\n\nThe grey half-strip D contains all points to the right of A. The map (1,1,0) carries D into A union C.  Hence, by Steps A and C, every point of D is mapped into \u03A9 by by an element of the Gauss group.\n\nLet E be the union of A,B,C,D. We now know that very point of E is mapped into \u03A9 by an element of the Gauss group. But every point of the plane, not in the green convex region, either lies in E or is mapped into E b the element (0,1,0). This completes the argument.";

    return(S);
    }


}



