import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;




public class DocumentIntro {

    public DocumentIntro() {}


    public static void setup(DocumentCanvas D) {
    
	String S="THE PROJECTIVE HEAT MAP\n\n";
        S=S+"Richard Evan Schwartz\n";
	S=S+"program started: 15 July 2013\n";
	S=S+"Last updated:  25 July 2016\n";

	    S=S+"\nOPERATING INSTRUCTIONS\n\n";

	    S=S+"This window gives explanations for the rest of the program.  Drag the mouse over the text to scroll up or down. (There is more text than what is now visible.) You can also resize this window by dragging from the bottom left corner. The text in this window will change if you press some of the black ?-boxes. If you want to return this text, press the black ?-box at top left.  This program also has a tutorial, which explains how to do specific things with the program.  If you want to operate the tutorial, you should keep this window open.";

	    S=S+"\n\nThis program is a companion to my monograph, which has the same title as the program.  The main part of the program is the large picture window, which displays in various ways the dynamics of a certain planar rational map which I call the projective midpoint map.  The program has a number of popup windows which you can summon by clicking on the rectangular buttons at the bottom left part of the main program.  Somewhat later in this introduction, I will give an overview of these other windows. ";


	    S=S+"This program is designed to work best with a 3 button mouse. On the picture window, buttoms 1 and 2 zoom in and out of the picture and button 2 selects a new point. If you don't have a 3 button mouse, you can use the keyboard buttons z,x,c to simulate the 3 buttons when you are operating the picture window. ";


	    S=S+"\n\nTHE MAP\n\n";

	    S=S+"The purpose of this program is to explore the dynamics of a rational planar map H which represents the projective midpoint map acting on the space of projective equivalence classes of real pentagons.  The projective midpoint map is a projectively natural iteration on polygons which shares some features of the midpoint usual midpoint map.  The usual midpoint replaces a given polygon P1 by the polygon P2 whose vertices are the midpoints of the sides of P1. The projective midpoint replaces P1 by the polygon whose vertices are the projective midpoints of the sides of P1.  (One needs 3 consecutive sides to determine the projective midpoint of the middle side.) The construction is described in the monograph.";

	    S=S+"\n\nThe space of projective classes of pentagons is birationally equivalent to the plane.  The monograph explains a specific coordinate system we use.  When we look at the geometric construction in coordinates, we get the map H listed in the FORMULAS popup window. We further conjugate B by a change of coordinates map B.  The conjugate of H by B has nicer geometric properties than H does, even though the formulas are more complicated.";

	    S=S+"\n\nAs practice, see if you can open up the FORMULAS window and see the formula for H and for B.  When you are done with the FORMULAS window, you can kill it.";

	    S=S+"\n\nTHE GAUSS GROUP";

	    S=S+"\n\nIn order to choose our coordinates, we have a select a pair of consecutive vertices on the pentagon.  Then, when we apply the geometric construction, we need to again pick a pair of consecutive coordinates.  The operation of changing the choice of vertices corresponds to a certain order 10 birational group action \u0393 on the plane.  We call this group the Gauss group because of its connection to something called Gauss's Pentagrammum Mirificum. A primary map is obtained as follows: We compose H with a member of the Gauss group and then conjugate the whole thing by B.  The FORMULAS window has a formula for this.  There are 10 primary maps,and you can s=access then using the buttons on the green rectangle on the control panel labeled `map'";

	    S=S+"\n\nThe competely canonical object is the semigroup generated by H and \u0393.  The green rectangle on the control panel labeled `map' allows you to specify elements in this semigroup.  Again, the FORMULAS window explains how the buttons on this green window correspond to elements of the semigroup.  On the green window, the primary maps have codes:";

	    S=S+"\n\n001,011,021,031,041,101,111,121,131,141.";
	     S=S+"\n\nThe elements of \u0393 have codes.";
	     S=S+"\n\n000,010,020,030,040,100,110,120,130,140.";

            S=S+"\n\nCONVEX PENTAGONS";

	    S=S+"\n\nIn our coordinates, the set of points in the plane representing projective classes of convex pentagons is the unbounded green region that looks a bit like a Swiss cross. If you zoom out of the picture window, you can see more of the green region.  Let C denote this green region.  One of the main results proved in the monograph is that almost every pentagon class maps into C under finite iteration.";

            S=S+"\n\nTHE JULIA SET";

S=S+"\n\nTo understand which points map into C, we color points in the plane according to how many iterates it takes them to land in C. This coloring highlights a fractal set J consisting of points which never map into C.  The set J, which you see in the picture window, is the Julia set for the map. The main point of the monograph is to show that J is connected and has measure zero, and to understand the topological structure of J.   This program lets you follow along with the monograph and perform the computational tests there.  By playing around with the program, you can get a much better sense of the dynamics than just by reading the monograph.";

	    S=S+"\n\nGENERAL APPROACH";

	    S=S+"\n\nOur approach to understanding J is as follows.  First of all, we observe that a certain triangle is a fundamental domain for the action of the Gauss group G. This triangle, T, is colored blue in the picture window.  Second, we partition T into small polygons on which at least one of the ten primary maps acts nicely.   Whenever you click on a piece of the partition, the program activates a pre-selected primary map which acts nicely there.  Once you have this map, you can perform various tests on it. For instance, you can test that it does not blow up on the domain, or that it is nonsingular, or a diffeomorphism, or an expanding map (as the case may be.) The tutorial will explain how to perform these various tests.";

	    S=S+"\n\nPOPUP WINDOWS";

	    S=S+"\n\nHere is a brief account of the popup windows.  When you open these windows and click on the question boxes, you can get more information.";

	    S=S+"\n\nTUTORIAL:  This window explains how to do various things, like scale the window, perform computational tests, change coordinates, and so on.  You should keep this window open when using the tutorial.  When you push a button on the tutorial, the text appears here.";

	    S=S+"\n\nPLOT DETAILS: This window lets you adjust things having to do with the plot, such as the colors of various displays and the way the scaling works.";

	    S=S+"\n\nPOLY SELECT: As we mentioned above, the bulk of this program involves performing computational tests on various polygons.  This window lets you change the domain for the tests.  If you want to see the domains for the tests, you should click on the `polygons' feature on the display panel.  In general, the test domain coincides with the partition piece you click on.  However, for the purposes of experimentation, you can change the domain of the tests.  The instructions in the tutorial and in this window tell you how to do this.";

	    S=S+"\n\nPOLY COORDS:  This window displays the coordinates of the polygonal domains of the computational tests. Sometimes the tests involve two regions, which we call the DOMAIN and the CONTAINER.  In a typical test, we will want to show that H(X) is a subset of Y, where X is the domain and Y is the container.  On this window you can toggle the display to show the coordinates either of the DOMAIN or of the CONTAINER.";

	    S=S+"\n\nPARTITION:  This window lets you manage the partition.  When you click on the buttons in this window you can select various partition pieces.  The pieces are labeled exactly as in the monograph.";

	    S=S+"\n\nTHE TESTS:  This window has the interface which lets you manage and perform the computational tests.  The tutorial and the documentation on this window explain how to do the tests.";

	    S=S+"\n\nDEBUGGER:  This window brings up some routines I wrote along the way, to make sure that the program is operating correctly.  These routines have their own documentation.";

	    S=S+"\n\nHere is an exercise to help you get a sense of the program.  Click on each of the rectangles controlling the popup windows (except the instructions, which are already present).  After looking at the window, kill it and move to the next one.";


        D.setExplain(S);
        D.repaint();   
	D.Y0=0;
        D.Y1=0;

    }
}

