import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;



/**this class lets you select the map.*/

public class HandleTestCone {
    int X,Y; //location of control panel 
    ListenSquare I; //documentation
    SelectInteger[][] V=new SelectInteger[4][2]; 
    SelectInteger[] S=new SelectInteger[2];
    ListenSquare NEGATE; //negates second cone
    /**replaces second cone W by the cone whose bounding lines
       are orthogonal to the bounding lines of W*/
    ListenSquare ORTHO; 


    public HandleTestCone(int x,int y) {
	X=x;
	Y=y;
	I=new ListenSquare(X+83,Y,12,12);
	int ypos=Y+40;
	for(int j=0;j<4;++j) {
	  for(int i=0;i<2;++i) {
	    V[j][i]=new SelectInteger(X+20+60*i,ypos,30,18,1,-20,20,1);
	  }
	  ypos=ypos+30;
	  if(j==1) ypos=ypos+40;
	}
	V[1][0].val=-1;
	V[3][0].val=-1;
	S[0]=new SelectInteger(X+25,Y+235,30,15,2,-500,500,1);
	S[1]=new SelectInteger(X+25,Y+257,30,15,-1,-500,500,1);
	NEGATE=new ListenSquare(X+225,Y+226,20,20);
	ORTHO=new ListenSquare(X+225,Y+256,20,20);
    }

    public void render(Graphics2D g) {
	I.infoRender(g);
	g.setColor(new Color(100,0,150));
	g.fillRect(X,Y,255,295);
	g.setColor(Color.white);
	g.drawRect(X,Y,255,295);
	for(int i=0;i<2;++i) S[i].render(g,Color.red,Color.white,Color.white);

	for(int j=0;j<4;++j) {
	    for(int i=0;i<2;++i) {
              V[j][i].render(g,Color.red,Color.white,Color.white);
	    }
	}

	g.setFont(new Font("Helvetica",Font.PLAIN,12));
	g.setColor(Color.yellow);
	g.drawString("V cone basis",X+30,Y+30);
	g.drawString("W cone basis",X+30,Y+130);
	g.drawString("Test dF(V).W \u2265 A",X+10,Y+220);
	Double d=new Double(convert(S[0].val,S[1].val));
	g.drawString(d.toString(),X+10,Y+288);
	g.drawString("A=",X+5,Y+246);
	g.drawString("+",X+13,Y+268);
	g.drawString("\u03C6",X+90,Y+268);

	NEGATE.render(g,Color.blue);
	ORTHO.render(g,Color.blue);
	g.drawString("negate cone",X+150,Y+240);
	g.drawString("ortho cone",X+150,Y+270);

	int[] a1={0,1};
	int[] a2={2,3};


	g.translate(145,-200);
	drawVectors(g,a1);
	g.translate(-145,200);

	g.translate(145,-90);
	drawVectors(g,a2);
	g.translate(-145,90);
    }


    public void drawVectors(Graphics2D g,int[] a) {
	g.setColor(Color.black);
	g.fillRect(X+5,Y+210,100,100);
	g.setColor(Color.white);
	g.drawRect(X+5,Y+210,100,100);

	g.setColor(new Color(80,80,80));
	g.drawLine(X+55,Y+210,X+55,Y+310);
	g.drawLine(X+5,Y+260,X+105,Y+260);

	double[][] d=new double[2][2];
	double max=0;
	for(int j=0;j<2;++j) {
	    for(int i=0;i<2;++i) {
		d[i][j]=V[a[i]][j].val;
		double test=Math.abs(d[i][j]);
		if(max<test) max=test;
	    }
	}

	for(int j=0;j<2;++j) {
	    for(int i=0;i<2;++i) {
		d[i][j]=50*d[i][j]/max;
	    }
	}

	g.setColor(Color.white);
	g.setStroke(new BasicStroke(2));
	Path2D.Double gp=new Path2D.Double();
	for(int j=0;j<2;++j) {
	  gp.moveTo(X+55,Y+260);
	  gp.lineTo(X+55+d[j][0],Y+260-d[j][1]);
	  g.draw(gp);
	}
	g.setStroke(new BasicStroke(1));


	g.setColor(new Color(255,0,255));
	g.drawRect(X+5,Y+210,100,100);

    }

    public int process(Point X) {
	if(I.inside(X)==1) return(99);
	for(int j=0;j<4;++j) {
	  for(int i=0;i<2;++i) V[j][i].modify(X);
	}
	for(int i=0;i<2;++i) S[i].modify(X);

	if(NEGATE.inside(X)==1) {
	    for(int i=2;i<4;++i) {
		for(int j=0;j<2;++j) V[i][j].val=-V[i][j].val;
	    }
	}
	if(ORTHO.inside(X)==1) {
	    int a20=V[2][0].val;
	    int a21=V[2][1].val;
	    int a30=V[3][0].val;
	    int a31=V[3][1].val;
	    V[3][0].val=-a21;
	    V[3][1].val= a20;
	    V[2][0].val= a31;
	    V[2][1].val=-a30;
	}
	return 0;
    }

    public static double convert(int a,int b) {
	double phi=(Math.sqrt(5)+1)/2;
	return(a+b*phi);
    }



    public QI2[][] getBounds() {
	QI2[][] b=new QI2[4][5];
	int k=0;
	for(int i=0;i<2;++i) {
	    for(int j=0;j<2;++j) {
	       b[k][0]=new QI2(V[i+0][0].val,0);
	       b[k][1]=new QI2(V[i+0][1].val,0);
	       b[k][2]=new QI2(V[j+2][0].val,0);
	       b[k][3]=new QI2(V[j+2][1].val,0);
	       b[k][4]=new QI2(S[0].val,S[1].val);
	       ++k;
	    }
	}
	return(b);
    }

}
