import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;

public class QISign {

    /**This tells if a number a + b sq5 is positive*.
       The idea is that (a+b sq5)(a-bsq5)=a^2-5b^2.
       So, if we know the sign of a,b, we know the
       sign of a-b sq5.  Hence, we can determine the
       sign of a+b sq5 from a^2-5b^2.*/

    public static boolean isPositive(BigInteger a,BigInteger b) {
	BigInteger N0=new BigInteger("0");
	BigInteger N5=new BigInteger("5");
	int ca=a.compareTo(N0);
	int cb=b.compareTo(N0);
	if(ca+cb<0) return(false);
	if(ca+cb>0) return(true);
	if((ca==0)&&(cb==0)) return(false);
	BigInteger A=a.multiply(a);
	BigInteger B=N5.multiply(b.multiply(b));
	if(A.compareTo(B)==ca) return(true);
	return(false);
    }

    /**This tells if a number a + b sq5 = 0*/
    public static boolean isZero(BigInteger a,BigInteger b) {
	BigInteger N0=new BigInteger("0");
	if(a.compareTo(N0)!=0) return(false);
	if(b.compareTo(N0)!=0) return(false);
	return(true);
    }

    /**This tells if a number a + b sqrt(5) is negative*/
    public static boolean isNegative(BigInteger a,BigInteger b) {
	BigInteger N0=new BigInteger("0");
	BigInteger aa=N0.subtract(a);
	BigInteger bb=N0.subtract(b);
	return(isPositive(aa,bb));
    }

    /**This tells if (a+ b sq5) + (c+d sq5 )sq13 is positive. 
       We make a similar trick, using the identity 
       (x+ ysq13)(x-ysq13)=x^2-13y^2*/

    public static boolean isPositive(BigInteger a,BigInteger b,BigInteger c,BigInteger d) {
	BigInteger N2=new BigInteger("2");
	BigInteger N5=new BigInteger("5");
	BigInteger N13=new BigInteger("13");
	BigInteger N26=new BigInteger("26");
	BigInteger N65=new BigInteger("65");
	boolean t1=isPositive(a,b);
	boolean t2=isPositive(c,d);
	boolean z1=isZero(a,b);
	boolean z2=isZero(c,d);
	if((z1==true)&&(z2==true)) return(false);
	if((t1==true)&&(z2==true)) return(true);
	if((t2==true)&&(z1==true)) return(true);
	if((t1==true)&&(t2==true)) return(true);
	BigInteger u=a.multiply(a);
	u=u.add(N5.multiply(b.multiply(b)));
	u=u.subtract(N13.multiply(c.multiply(c)));
	u=u.subtract(N65.multiply(d.multiply(d)));
	BigInteger v=N2.multiply(a.multiply(b));
	v=v.subtract(N26.multiply(c.multiply(d)));
	if(t1==true) return(isPositive(u,v));
	if(t2==true) return(isNegative(u,v));
	return(false);
    }
}
